<div class="profile-container">
  <form [formGroup]="personalForm">
    <mat-card>
      <mat-card-title>Personal Details</mat-card-title>
      <mat-card-content fxLayout="column">
        <mat-form-field>
          <input matInput formControlName="fullName" placeholder="Full Name">
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="email" placeholder="Email" readonly>
        </mat-form-field>
        <mat-form-field *ngIf="phone">
          <input matInput formControlName="phone" placeholder="Phone" readonly>
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="givenName" placeholder="First Name">
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="middleName" placeholder="Middle Name">
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="familyName" placeholder="Last Name">
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="nickname" placeholder="Nickname">
        </mat-form-field>
        <mat-form-field>
          <mat-select formControlName="gender" placeholder="Gender">
            <mat-option *ngFor="let g of genders" [value]="g">
              {{ g }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field>
          <mat-datepicker-toggle matSuffix [for]="birthdatePicker"></mat-datepicker-toggle>
          <input
            matInput
            formControlName="birthdate"
            [matDatepicker]="birthdatePicker"
            placeholder="Birthdate"
            [value]="birthdate"
            (dateInput)="updateBirthdate('input', $event)">
          <mat-datepicker #birthdatePicker disabled="false"></mat-datepicker>
        </mat-form-field>
      </mat-card-content>
      <mat-card-actions>
        <button (click)="updatePersonal()" mat-button color="primary" [disabled]="!personalForm.valid">Update</button>
        <button (click)="updatePhone()" *ngIf="enableUserPhone" mat-button>Update Phone</button>
      </mat-card-actions>
    </mat-card>
  </form>
</div>

<div class="profile-container">
  <form [formGroup]="profileForm">
    <mat-card>
      <div fxLayout="row" fxLayoutAlign="space-between none">
        <mat-card-title>Profile Details</mat-card-title>
        <img
          mat-card-avatar
          (click)="toggleFileField()"
          [src]="picture"
          *ngIf="picture">
        <div
          mat-card-avatar
          class="avatar-image"
          (click)="toggleFileField()"
          *ngIf="!picture">
        </div>
      </div>
      <mat-card-content fxLayout="column">
        <mat-form-field *ngIf="hideAvatar">
          <ngx-mat-file-input
            formControlName="picture"
            type="file"
            (change)="onFileChanged($event)"
            placeholder="Avatar"
            accept="image/*"
            valuePlaceholder="{{ avatarUrl }}" #fileInput></ngx-mat-file-input>
            <mat-icon matSuffix>folder</mat-icon>
        </mat-form-field>
        <mat-form-field>
          <input matInput formControlName="website" placeholder="Website">
        </mat-form-field>
        <mat-form-field>
          <mat-select formControlName="zoneinfo" placeholder="Time Zone">
            <mat-option *ngFor="let timezone of timezones" [value]="timezone.abbr">
              {{ timezone.text }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field>
          <mat-select formControlName="locale" placeholder="Locale">
            <mat-option *ngFor="let l of locales" [value]="l.code">
              {{ l.name }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-card-actions>
          <button
            (click)="updateProfile()"
            mat-button color="primary">Update</button>
          <button
            *ngIf="hideAvatar && picture !== missingAvatarImage"
            mat-button
            color="warn"
            (click)="deleteAvatar()">Delete Avatar</button>
        </mat-card-actions>
      </mat-card-content>
    </mat-card>
  </form>
</div>

<div class="profile-container">
  <mat-card>
    <mat-card-title>Access Details</mat-card-title>
    <mat-card-subtitle>Roles and Groups</mat-card-subtitle>
    <mat-card-content fxLayout="column" fxAlignLayout="space-evenly none" fxLayoutGap="1em">
      <mat-chip-list>
        <mat-chip *ngFor="let role of roles" disabled>
          {{ role }}
        </mat-chip>
      </mat-chip-list>
    </mat-card-content>
  </mat-card>
</div>

<div class="profile-container">
  <mat-card>
    <mat-card-title>Security Details</mat-card-title>
    <mat-card-subtitle>Multi Factor Authentication</mat-card-subtitle>
    <mat-card-content fxLayout="column" fxAlignLayout="space-evenly none" fxLayoutGap="1em">
      <mat-slide-toggle
        [checked]="checked2fa"
        (click)="enableDisable2fa()">
        {{ checked2fa ? 'Enabled' : 'Disabled' }}
      </mat-slide-toggle>
    </mat-card-content>
    <mat-card-actions>
      <button (click)="manageKeys()" mat-button color="primary">Manage Keys</button>
      <button *ngIf="!enablePasswordLess" (click)="enablePasswordLessLogin()" mat-button>Enable Password-less</button>
      <button *ngIf="enablePasswordLess" (click)="disablePasswordLess()" mat-button>Disable Password-less</button>
    </mat-card-actions>
  </mat-card>
</div>

<div class="profile-container" *ngIf="isPasswordSet">
  <mat-card>
    <div fxLayout="row" fxLayoutAlign="space-between none">
      <mat-card-title>Change Password</mat-card-title>
    </div>
    <form *ngIf="showPasswordSection" (ngSubmit)="changePasswordRequest()" [formGroup]="changePasswordForm">
      <mat-card-content fxLayout="column">
        <mat-form-field>
          <input matInput type="password" formControlName="currentPassword" placeholder="Current Password" required>
        </mat-form-field>
        <mat-form-field>
          <input matInput type="password" formControlName="newPassword" placeholder="New Password" required>
        </mat-form-field>
        <mat-form-field>
          <input matInput type="password" formControlName="repeatPassword" placeholder="Repeat Password" required>
        </mat-form-field>
        <app-password-requirement></app-password-requirement>
      </mat-card-content>
      <mat-card-actions>
          <button type="submit" mat-button color="primary">Update</button>
      </mat-card-actions>
    </form>
    <mat-card-actions *ngIf="!showPasswordSection">
      <button (click)="showChangePassword()" mat-button color="primary">Change Password</button>
    </mat-card-actions>
  </mat-card>
</div>

<div class="profile-container" *ngIf="!isPasswordSet">
  <mat-card>
    <div fxLayout="row" fxLayoutAlign="space-between none">
      <mat-card-title>Set Password</mat-card-title>
    </div>
    <mat-card-actions>
      <button
        (click)="setPassword()"
        mat-button
        [disabled]="sentForgotPasswordEmail"
        color="primary">Send Email</button>
    </mat-card-actions>
    </mat-card>
</div>

<div class="profile-container">
  <mat-card>
    <mat-card-title>Delete User</mat-card-title>
    <mat-card-subtitle *ngIf="!checkIfAdmin()">Deleting User Account is irreversible</mat-card-subtitle>
    <mat-card-subtitle *ngIf="checkIfAdmin()">Administrator cannot be deleted</mat-card-subtitle>
    <mat-card-content></mat-card-content>
    <mat-card-actions>
      <button [disabled]="checkIfAdmin()" (click)="deleteUser()" mat-button color="warn">Delete User</button>
    </mat-card-actions>
  </mat-card>
</div>
